#ifndef DETECT_DRIVER_IOCTL_H_INCLUDED
#define DETECT_DRIVER_IOCTL_H_INCLUDED

/* This file defines Input-Output Control Codes to communicate with DetectDriver. */

/*
All input strings(parameters) is UNICODE strings.

Format of output string:
First byte contain type of information returned:
QUERY_SUCCESS or QUERY_FAIL
After this byte placed output information.
[STATUS BYTE][INFORMATION]
*/

#define QUERY_SUCCESS 1
#define QUERY_FAIL    2


/*-----------------------------------------------------------------------*/
/*                            Hidden processes detect IOCTLs                */

#define IOCTL_PROCESSES_QUERY_HIDEN CTL_CODE( \
    FILE_DEVICE_UNKNOWN, 0x601, METHOD_BUFFERED, FILE_ANY_ACCESS)

/*
This IOCTL used to query detected hidden process.
No input paramters.
*/

/*-----------------------------------------------------------------------*/


/*-----------------------------------------------------------------------*/
/*                            Hidden files detect IOCTLs                  */

#define IOCTL_FILES_START_DETECT CTL_CODE( \
    FILE_DEVICE_UNKNOWN, 0x701, METHOD_BUFFERED, FILE_ANY_ACCESS)

/*
This IOCTL used to start detection of hidden files.
Input parameter is path to directory where search hidden files.
*/

#define IOCTL_FILES_STOP_DETECT CTL_CODE( \
    FILE_DEVICE_UNKNOWN, 0x702, METHOD_BUFFERED, FILE_ANY_ACCESS)

/*
This IOCTL used to start detection of hidden files.
No input paramters.
*/

enum FilesDetectStatus
{
    FILES_DETECT_STATUS_EMPTY,
    FILES_DETECT_STATUS_RUNNING,
    FILES_DETECT_STATUS_FINISHED,
    FILES_DETECT_STATUS_ABORTED
};

enum FileDetectFlags
{
    FILES_DETECT_FLAG_EMPTY,
    FILES_DETECT_FLAG_NEW_HIDDEN_FILE,
    FILES_DETECT_FLAG_ERROR
};

#define IOCTL_FILES_QUERY_STATUS CTL_CODE( \
    FILE_DEVICE_UNKNOWN, 0x703, METHOD_BUFFERED, FILE_ANY_ACCESS)

/*
This IOCTL used to query status of detection of hidden files.
No input paramters.
*/

#define IOCTL_FILES_QUERY_HIDEN CTL_CODE( \
    FILE_DEVICE_UNKNOWN, 0x705, METHOD_BUFFERED, FILE_ANY_ACCESS)

/*
This IOCTL used to query detected hidden files.
No input paramters.
*/

#define IOCTL_FILES_QUERY_ERROR CTL_CODE( \
    FILE_DEVICE_UNKNOWN, 0x706, METHOD_BUFFERED, FILE_ANY_ACCESS)

/*
This IOCTL used to query error string.
No input paramters.
*/

/*-----------------------------------------------------------------------*/


#endif // #ifndef DETECT_DRIVER_IOCTL_H_INCLUDED)