#pragma once

#include <string>

namespace DetectDriver
{
struct IDetectObserver
{
    virtual void AddHiddenRecord(const std::wstring& path)=0;   

    virtual void OnDirProcessing(const std::wstring& dirPath)=0;

    virtual bool IsStoped()const=0;
};

struct StopException:public std::exception
{
    StopException(const char* error)
        : std::exception(error)
    {}
};

void DetectHiddenFiles(const std::wstring& path,IDetectObserver* observer);

}