#pragma once

#include "drvCommon.h"
#include <list>
#include <string>

namespace DetectDriver
{

typedef SYSTEM_PROCESSES_INFORMATION ProcessInfoList;
typedef ProcessInfoList *ProcessInfoListPtr;

struct ProcessInfoShort
{
	ULONG pid;
	std::wstring name;
};
typedef std::list<ProcessInfoShort> ProcInfoShortList;

struct ProcessInfoFull:public ProcessInfoShort
{
	std::wstring imagePath;
};
typedef std::list<ProcessInfoFull> ProcInfoFullList;

void ExamineList(ProcessInfoListPtr hookedListIn,
				 ProcessInfoListPtr originalListIn,
				 ProcInfoShortList* hiddenList);

bool IsListsEqual(ProcessInfoListPtr hookedList,
				  ProcessInfoListPtr originalList);

}//namespace DetectDriver