#include "stdafx.h"
#include "GUIApp.h"
#include "ListForm.h"

#include "DriverWork.h"
#include <string>

// ListForm

IMPLEMENT_DYNCREATE(ListForm, CFormView)

ListForm::ListForm()
    : CFormView(ListForm::IDD)
{}

ListForm::~ListForm()
{}

void ListForm::DoDataExchange(CDataExchange* pDX)
{
    CFormView::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_LIST, listCtrl_);
}

BEGIN_MESSAGE_MAP(ListForm, CFormView)
    ON_BN_CLICKED(IDC_BUTTON_START_STOP, &ListForm::OnBnClickedButtonStartStop)
END_MESSAGE_MAP()


// ListForm diagnostics
#ifdef _DEBUG
void ListForm::AssertValid() const
{
    CFormView::AssertValid();
}
void ListForm::Dump(CDumpContext& dc) const
{
    CFormView::Dump(dc);
}
#endif //_DEBUG


// ListForm message handlers

void ListForm::OnInitialUpdate()
{
    CFormView::OnInitialUpdate();

	DWORD dwExStyle_f=listCtrl_.GetExtendedStyle();
	dwExStyle_f= (LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);
	listCtrl_.SetExtendedStyle(dwExStyle_f);

	InitializeListCtrl(listCtrl_);
}


void ListForm::OnBnClickedButtonStartStop()
{
    try
    {
        /*if( !utils::DriverWork::IsInstalled( _T("\\\\.\\DetectDriver") ) )
        {
            SetStatus(L"Driver not installed");
            return;
        }

        if( !utils::DriverWork::IsLoaded( _T("\\\\.\\DetectDriver") ) )
        {
            SetStatus(L"Driver not loaded");
            return;
        }*/

        OnButtonClick(listCtrl_);
    }
    catch(const std::exception& ex)
    {
        ::MessageBoxA(this->GetSafeHwnd(),ex.what(),"Error",MB_ICONERROR|MB_OK);
        return;
    }
}

void ListForm::SetStatus(const std::wstring& status)
{
    SetDlgItemText(IDC_STATIC_STATUS,status.c_str());
}