#include "drvCommon.h"

#include "CustomFileApi.h"

extern "C"
{

typedef NTSTATUS (*NtClosePtr)(
    IN HANDLE Handle
);

typedef NTSTATUS (*NtQueryDirInfoPtr)(
    IN HANDLE                   FileHandle,
    IN HANDLE                   Event OPTIONAL,
    IN PIO_APC_ROUTINE          ApcRoutine OPTIONAL,
    IN PVOID                    ApcContext OPTIONAL,
    OUT PIO_STATUS_BLOCK        IoStatusBlock,
    OUT PVOID                   FileInformation,
    IN ULONG                    Length,
    IN FILE_INFORMATION_CLASS   FileInformationClass,
    IN BOOLEAN                  ReturnSingleEntry,
    IN PUNICODE_STRING          FileName OPTIONAL,
    IN BOOLEAN                  RestartScan
);

typedef NTSTATUS (*NtOpenFilePtr)(
           OUT PHANDLE FileHandle,
           IN ACCESS_MASK DesiredAccess,
           IN POBJECT_ATTRIBUTES ObjectAttributes,
           OUT PIO_STATUS_BLOCK IoStatusBlock,
           IN ULONG ShareAccess,
           IN ULONG OpenOptions
           );
};

namespace utils
{

NTSTATUS CustomFileApi::Close(HANDLE handle)
{
    return ((NtClosePtr)pClose_)(handle);
}

NTSTATUS CustomFileApi::OpenFile(PHANDLE FileHandle,
                                 ACCESS_MASK DesiredAccess,
                                 POBJECT_ATTRIBUTES ObjectAttributes,
                                 PIO_STATUS_BLOCK IoStatusBlock,
                                 ULONG ShareAccess,
                                 ULONG OpenOptions)
{
    return ((NtOpenFilePtr)pOpenFile_)
                     (FileHandle,
                      DesiredAccess,
                      ObjectAttributes,
                      IoStatusBlock,
                      ShareAccess,
                      OpenOptions);
}

NTSTATUS CustomFileApi::QueryDirFile(HANDLE FileHandle,
                                     PIO_STATUS_BLOCK IoStatusBlock,
                                     PVOID FileInformation,
                                     ULONG Length,
                                     FILE_INFORMATION_CLASS FileInformationClass,
                                     BOOLEAN ReturnSingleEntry)
{
    return ((NtQueryDirInfoPtr)pQueryDirFile_)
        (FileHandle,
         NULL,
         NULL,
         NULL,
         IoStatusBlock,
         FileInformation,
         Length,
         FileInformationClass,
         ReturnSingleEntry,
         NULL,
         FALSE);
}

}