#include "drvCommon.h"

#include "FileFindApi.h"


namespace utils
{

HANDLE FileFindApi::FindFirstFile(const wchar_t* fileName,
                                  FileFindBuffer* findFileData)
{
    UNICODE_STRING filePath;
    
    RtlInitUnicodeString(&filePath,fileName);


    OBJECT_ATTRIBUTES obja;
    InitializeObjectAttributes(&obja,
                               &filePath,
                               OBJ_CASE_INSENSITIVE,
                               NULL,
                               NULL);

    NTSTATUS status;
    HANDLE hFindFile;
    IO_STATUS_BLOCK ioStatusBlock;
    status = envApi_->OpenFile(&hFindFile,
                               FILE_LIST_DIRECTORY | SYNCHRONIZE,
                               &obja,
                               &ioStatusBlock,
                               FILE_SHARE_READ | FILE_SHARE_WRITE,
                               FILE_DIRECTORY_FILE | FILE_SYNCHRONOUS_IO_NONALERT | FILE_OPEN_FOR_BACKUP_INTENT);

    if ( !NT_SUCCESS(status) ) 
        return INVALID_HANDLE_VALUE;

    status = envApi_->QueryDirFile(hFindFile,
                                   &ioStatusBlock,
                                   &findFileData->dirInfo,
                                   sizeof(FileFindBuffer),
                                   FileBothDirectoryInformation,
                                   TRUE);

    if ( !NT_SUCCESS(status) ) 
    {
        ZwClose(hFindFile);
        return INVALID_HANDLE_VALUE;
    }

    return hFindFile;
}

BOOL FileFindApi::FindNextFile(HANDLE hFindFile,
                               FileFindBuffer* findFileData)
{
    IO_STATUS_BLOCK ioStatusBlock;
    NTSTATUS status = envApi_->QueryDirFile(hFindFile,
                                            &ioStatusBlock,
                                            &findFileData->dirInfo,
                                            sizeof(FileFindBuffer),
                                            FileBothDirectoryInformation,
                                            TRUE);

    return NT_SUCCESS(status); 
}

BOOL FileFindApi::FindClose(HANDLE hFindFile)
{
    NTSTATUS status = ZwClose(hFindFile);
    return NT_SUCCESS(status);
}

}