#include "drvCommon.h"

#include "FileSearcher.h"
#include "FileFind.h"

#include <stack>
#include <boost/shared_ptr.hpp>

namespace utils
{

typedef boost::shared_ptr<FileFind> FileFindPtr;
struct State
{
    FileFindPtr findPtr;
    bool bWorking;
};
typedef std::stack<State> FileFindStack; 

void FileSearcher::StartSearch(const std::wstring& startPath)
{
    FileFindStack finderStack;
    FileFindPtr finder( new FileFind(envApi_) );

    BOOL bWorking = finder->FindFile( startPath.c_str() );
    while( bWorking )
    {
        bWorking = finder->FindNextFile();

        if( finder->IsDots() )
            goto CntinueCheckRet;

        if( finder->IsDirectory() )
            observer_->OnDirFound( finder->GetFilePath(), finder->GetAllInfo());
        else
            observer_->OnFileFound( finder->GetFilePath(), finder->GetAllInfo() );

        if( finder->IsDirectory() )
        {
            FileFindPtr newFinder(new FileFind(envApi_));
            BOOL ret = newFinder->FindFile( finder->GetFilePath() + L"\\" );
            if( ret )
            {
                State state = {finder,bWorking};
                finderStack.push(state);
                bWorking = true;
                finder = newFinder;
                continue;
            }
        }

CntinueCheckRet:
        while( !bWorking && !finderStack.empty() )
        {
            State state = finderStack.top();
            finderStack.pop();

            finder = state.findPtr;
            bWorking = state.bWorking;
        }
    }
}

void FileEnumerator::StartEnumeration(const std::wstring& startPath)
{
    FileFind finder(envApi_);
    BOOL bWorking = finder.FindFile(startPath);
    while (bWorking)
    {
        bWorking = finder.FindNextFile();

        if( finder.IsDots() )
            continue;

        if( finder.IsDirectory() )
            observer_->OnDirFound( finder.GetFilePath(), finder.GetAllInfo());
        else
            observer_->OnFileFound( finder.GetFilePath(), finder.GetAllInfo() );
    }
}


}
