#pragma once

#include <string>

#include "DirInfo.h"
#include "FileFindApi.h"

namespace utils
{
struct IFileObserver
{
    virtual ~IFileObserver(){}

    virtual void OnFileFound(const std::wstring& filePath,DirInfo* info)=0;
    virtual void OnDirFound(const std::wstring& dirPath,DirInfo* info)=0;
};

class FileSearcher
{
    IEnvFileApi* envApi_;
    IFileObserver* observer_;
public:
    FileSearcher(IFileObserver* observer,
                 IEnvFileApi* envApi)
        : observer_(observer)
        , envApi_(envApi)
    {}

    void StartSearch(const std::wstring& startPath);
};

class FileEnumerator
{
    IEnvFileApi* envApi_;
    IFileObserver* observer_;
public:
    FileEnumerator(IFileObserver* observer,
                   IEnvFileApi* envApi)
        : observer_(observer)
        , envApi_(envApi)
    {}

    void StartEnumeration(const std::wstring& startPath);
};

}