#include "drvCommon.h"

#include "KernelFileApi.h"

extern "C"
{
NTSYSAPI
NTSTATUS
NTAPI
NtClose(
    IN HANDLE Handle
);

NTSYSAPI
NTSTATUS
NTAPI
NtQueryDirectoryFile (
    IN HANDLE                   FileHandle,
    IN HANDLE                   Event OPTIONAL,
    IN PIO_APC_ROUTINE          ApcRoutine OPTIONAL,
    IN PVOID                    ApcContext OPTIONAL,
    OUT PIO_STATUS_BLOCK        IoStatusBlock,
    OUT PVOID                   FileInformation,
    IN ULONG                    Length,
    IN FILE_INFORMATION_CLASS   FileInformationClass,
    IN BOOLEAN                  ReturnSingleEntry,
    IN PUNICODE_STRING          FileName OPTIONAL,
    IN BOOLEAN                  RestartScan
);


NTSYSAPI
NTSTATUS
NTAPI
NtOpenFile(
           OUT PHANDLE FileHandle,
           IN ACCESS_MASK DesiredAccess,
           IN POBJECT_ATTRIBUTES ObjectAttributes,
           OUT PIO_STATUS_BLOCK IoStatusBlock,
           IN ULONG ShareAccess,
           IN ULONG OpenOptions
           );

};
namespace utils
{

NTSTATUS ZwFileApi::Close(HANDLE handle)
{
    return ZwClose(handle);
}
NTSTATUS ZwFileApi::OpenFile(PHANDLE FileHandle,
                             ACCESS_MASK DesiredAccess,
                             POBJECT_ATTRIBUTES ObjectAttributes,
                             PIO_STATUS_BLOCK IoStatusBlock,
                             ULONG ShareAccess,
                             ULONG OpenOptions)
{
    return ZwOpenFile(FileHandle,
                      DesiredAccess,
                      ObjectAttributes,
                      IoStatusBlock,
                      ShareAccess,
                      OpenOptions);
}

NTSTATUS ZwFileApi::QueryDirFile(HANDLE FileHandle,
                                 PIO_STATUS_BLOCK IoStatusBlock,
                                 PVOID FileInformation,
                                 ULONG Length,
                                 FILE_INFORMATION_CLASS FileInformationClass,
                                 BOOLEAN ReturnSingleEntry)
{
    return ZwQueryDirectoryFile(FileHandle,
                                NULL,
                                NULL,
                                NULL,
                                IoStatusBlock,
                                FileInformation,
                                Length,
                                FileInformationClass,
                                ReturnSingleEntry,
                                NULL,
                                FALSE);
}

NTSTATUS NtFileApi::Close(HANDLE handle)
{
    return NtClose(handle);
}

NTSTATUS NtFileApi::OpenFile(PHANDLE FileHandle,
                             ACCESS_MASK DesiredAccess,
                             POBJECT_ATTRIBUTES ObjectAttributes,
                             PIO_STATUS_BLOCK IoStatusBlock,
                             ULONG ShareAccess,
                             ULONG OpenOptions)
{
    return NtOpenFile(FileHandle,
                      DesiredAccess,
                      ObjectAttributes,
                      IoStatusBlock,
                      ShareAccess,
                      OpenOptions);
}

NTSTATUS NtFileApi::QueryDirFile(HANDLE FileHandle,
                                 PIO_STATUS_BLOCK IoStatusBlock,
                                 PVOID FileInformation,
                                 ULONG Length,
                                 FILE_INFORMATION_CLASS FileInformationClass,
                                 BOOLEAN ReturnSingleEntry)
{
    return NtQueryDirectoryFile(FileHandle,
                                NULL,
                                NULL,
                                NULL,
                                IoStatusBlock,
                                FileInformation,
                                Length,
                                FileInformationClass,
                                ReturnSingleEntry,
                                NULL,
                                FALSE);
}

}